# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}
%define repodir %{_javadir}/repository.jboss.com/hibernate/%{version}.%{reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src
%define section free
%define reltag GA_CP05
%define base_version 3.3
%define hname Hibernate3
%define namedversion %{version}.%{reltag}

Summary:        Relational persistence and query service
Name:           hibernate3
Version:        3.3.2
Release:        1.9.%{reltag}%{?dist}
Epoch:          1
License:        LGPL
URL:            http://www.hibernate.org/
Group:          Database

Source0:        hibernate-3.3.2.%{reltag}-src.tar.gz
Source1:        %{name}-component-info.xml
Source3:        %{name}-jpp-depmap.xml

Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 1.5.0
BuildRequires:  maven2,maven2-plugin-assembly,maven2-plugin-compiler,maven2-plugin-enforcer,maven2-plugin-install
BuildRequires:  maven2-plugin-jar,maven2-plugin-javadoc,maven2-plugin-resources,maven2-plugin-source
BuildRequires:  maven2-plugin-surefire,maven2-plugin-surefire-report,maven2-plugin-war,maven-injection-plugin
BuildRequires:  maven-doxia-sitetools,maven-release-plugin,maven-test-ext-plugin
BuildRequires:  mojo-maven2-plugin-antlr
BuildRequires:  jboss-parent,jboss-javaee,jboss-jaspi-1.0-api,jboss-transaction-1.0.1-api,jboss-jacc-1.1-api
BuildRequires:  javassist >= 0:3.9.0,cglib >= 0:2.2
BuildRequires:  jakarta-commons-collections >= 0:3.1
BuildRequires:  antlr >= 0:2.7.7
BuildRequires:  xpp3-minimal
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-site-plugin

## xml/xstl handling
BuildRequires:  dom4j >= 0:1.6.1,jaxen >= 0:1.1
## Treecache
BuildRequires:  jboss-cache-core >= 3.1.0,concurrent >= 0:1.3.4
## cache providers
BuildRequires:  ehcache >= 0:1.2.3,oscache >= 0:2.2,swarmcache
## connection pool
BuildRequires:  c3p0,proxool >= 0:0.8.3
BuildRequires:  hsqldb
BuildRequires:  slf4j >= 1.5.6,log4j >= 0:1.2.14
BuildRequires:  servlet_2_5_api,jacc_1_0_api
Requires:  java >= 0:1.5.0
Requires:  cglib >= 0:2.2
Requires:  objectweb-asm >= 3.1
Requires:  javassist >= 0:3.9.0
Requires:  jakarta-commons-collections >= 0:3.1
Requires:  jakarta-commons-logging-jboss >= 0:1.1
Requires:  antlr >= 0:2.7.7-7
Requires:  dom4j >= 0:1.6.1
Requires:  jboss-transaction-1.0.1-api
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Hibernate is a powerful, ultra-high performance 
object/relational persistence and query service 
for Java. Hibernate lets you develop persistent 
objects following common Java idiom - including 
association, inheritance, polymorphism, composition 
and the Java collections framework. Extremely 
fine-grained, richly typed object models are 
possible. The Hibernate Query Language, designed 
as a "minimal" object-oriented extension to SQL, 
provides an elegant bridge between the object and 
relational worlds. Hibernate is now the most 
popular ORM solution for Java.


%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:		 Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package zip
Summary:        Zip distrubution for %{name}
Group:          Development

%description zip
Zip distribution for %{name}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{hname}

sed -i "s|<module>jdbc3-testing</module>||g" pom.xml

find . -name "*.jar" -exec rm -f {} \;
%build

export MAVEN_REPO_LOCAL=$(pwd)/../m2/repository
%{_bindir}/mvn-jpp -e \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE3} \
        -Dmaven.test.failure.ignore=true \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/../maven2-brew \
        install deploy:deploy javadoc:javadoc
%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p */target/hibernate-*.jar $RPM_BUILD_ROOT%{_javadir}
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in hibernate-*.jar; do mv ${jar} `echo $jar | sed "s|hibernate|%{name}|g" | sed "s|-%{version}.%{reltag}|-%{version}|g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|%{name}|hibernate|g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
# etc
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc
cp -p etc/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc

# pom
%add_to_maven_depmap org.hibernate hibernate-core %{namedversion} JPP %{name}-core
%add_to_maven_depmap org.hibernate hibernate-jmx %{namedversion} JPP %{name}-jmx
%add_to_maven_depmap org.hibernate hibernate-jbosscache2 %{namedversion} JPP %{name}-jbosscache2
%add_to_maven_depmap org.hibernate hibernate-c3p0 %{namedversion} JPP %{name}-c3p0
%add_to_maven_depmap org.hibernate hibernate-ehcache %{namedversion} JPP %{name}-ehcache
%add_to_maven_depmap org.hibernate hibernate-oscache %{namedversion} JPP %{name}-oscache
%add_to_maven_depmap org.hibernate hibernate-proxool %{namedversion} JPP %{name}-proxool
%add_to_maven_depmap org.hibernate hibernate-swarmcache %{namedversion} JPP %{name}-swarmcache
%add_to_maven_depmap org.hibernate hibernate-parent %{namedversion} JPP %{name}-parent
%add_to_maven_depmap org.hibernate hibernate-testing %{namedversion} JPP %{name}-testing
%add_to_maven_depmap org.hibernate hibernate %{namedversion} JPP %{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 parent/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-parent.pom
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
install -m 644 core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-core.pom
install -m 644 jmx/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-jmx.pom
install -m 644 cache-jbosscache2/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-jbosscache2.pom
install -m 644 connection-c3p0/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-c3p0.pom
install -m 644 cache-ehcache/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-ehcache.pom
install -m 644 cache-oscache/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-oscache.pom
install -m 644 connection-proxool/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-proxool.pom
install -m 644 cache-swarmcache/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-swarmcache.pom
install -m 644 testing/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-testing.pom
# javadoc
# core/target/site/apidocs
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-core-%{version}
cp -pr core/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-core-%{version}
rm -rf core/target/site/apidocs
#jmx/target/site/apidocs
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-jmx-%{version}
cp -pr jmx/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-jmx-%{version}
rm -rf jmx/target/site/apidocs
#cache-jbosscache2/target/site/apidocs
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-jbosscache2-%{version}
cp -pr cache-jbosscache2/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-jbosscache2-%{version}
rm -rf cache-jbosscache2/target/site/apidocs
#cache-swarmcache/target/site/apidocs
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-swarmcache-%{version}
cp -pr cache-swarmcache/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-swarmcache-%{version}
rm -rf cache-swarmcache/target/site/apidocs
#connection-c3p0/target/site/apidocs
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-c3p0-%{version}
cp -pr connection-c3p0/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-c3p0-%{version}
rm -rf connection-c3p0/target/site/apidocs
#cache-ehcache/target/site/apidocs
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-ehcache-%{version}
cp -pr cache-ehcache/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-ehcache-%{version}
rm -rf cache-ehcache/target/site/apidocs
#connection-proxool/target/site/apidocs
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-proxool-%{version}
cp -pr connection-proxool/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-proxool-%{version}
rm -rf connection-proxool/target/site/apidocs
#cache-oscache/target/site/apidocs
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-oscache-%{version}
cp -pr cache-oscache/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-oscache-%{version}
rm -rf cache-oscache/target/site/apidocs

(cd $RPM_BUILD_ROOT%{_javadocdir} && for doc in *-%{version}; do ln -sf ${doc} `echo $doc| sed "s|%{name}|hibernate|g"`; done)
(cd $RPM_BUILD_ROOT%{_javadocdir} && for doc in *-%{version}; do ln -sf ${doc} `echo $doc| sed "s|-%{version}||g"`; done)

%if %{with_repolib}
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr ../maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
	tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
	sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -p -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{repodirsrc}
	(cd $RPM_BUILD_ROOT%{_javadir} && for jar in %{name}-*-%{version}*.jar; do cp -p ${jar} $RPM_BUILD_ROOT%{repodirlib}/`echo $jar| sed "s|-%{version}||g" | sed "s|%{name}|hibernate|g"`; done)
	(cd $RPM_BUILD_ROOT%{_datadir}/maven2/poms && for pom in JPP-%{name}*.pom; do cp -p ${pom} $RPM_BUILD_ROOT%{repodirlib}/`echo $pom| sed "s|JPP-%{name}|hibernate|g"`; done)
%endif

# dist
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/hibernate3-fordev
cp distribution/target/hibernate-distribution*.zip $RPM_BUILD_ROOT%{_javadir}/hibernate3-fordev/hibernate-dist.zip
# License
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p lgpl.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/lgpl.txt
%{_javadir}*/%{name}-*.jar
%{_javadir}*/hibernate-*.jar
%{_datadir}/%{name}-%{version}
%{_datadir}/maven2/poms/JPP-%{name}*.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-*
%{_javadocdir}/hibernate-*

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%files zip
%defattr(0644,root,root,0755)
%{_javadir}*/hibernate3-fordev/*.zip

%changelog
* Wed Jul 25 2012 Strong Liu <stliu@redhat.com> 3.3.2-1.9.GA_CP05
- Upgrade to 3.3.2.GA_CP05

* Sat May 07 2011 Strong Liu <stliu@redhat.com> 3.3.2-1.8.GA_CP04
- Rebuild

* Fri May 06 2011 Strong Liu <stliu@redhat.com> 3.3.2-1.7.GA_CP04
- Rebuild to include fix of JBPAPP-6472

* Tue Apr 05 2011 Strong Liu <stliu@redhat.com> 3.3.2-1.6.GA_CP04
- Remove hibernate3-JBossORG-EULA.txt 
- Upgrade antlr to 2.7.7 by patching parent/pom.xml

* Mon Apr 04 2011 Permaine Cheung <pcheung@redhat.com> 3.3.2-1.5.GA_CP04
- Fix VR on R: antlr

* Fri Mar 11 2011 Permaine Cheung <pcheung@redhat.com> 3.3.2-1.4.GA_CP04
- Add version to R: antlr

* Fri Feb 11 2011 Strong Liu <stliu@redhat.com> 3.3.2-1.3.GA_CP04
- Upgrade to 3.3.2.GA_CP04

* Fri Dec 17 2010 Yiqiao Wang <yiwang@redhat.com> 3.3.2-1.2.GA_CP03
- Build with Maven 2.2.1
- Fix %%files for signed jars
- Add content of maven2-brew, add BR maven-deploy-plugin
- Add the line to find and remove any binaries
- Change BR maven-release to maven-release-plugin
- Add BR xpp3-minimal and maven-site-plugin

* Sun Jul 25 2010 Strong Liu <stliu@redhat.com> 3.3.2-1.1.GA_CP03
- Upgrade to 3.3.2.GA_CP03

* Thu Jun 02 2010 Strong Liu <stliu@redhat.com> 3.3.2-1.0.GA_CP02
- Correct Release Number

* Fri May 21 2010 Strong Liu <stliu@redhat.com> 3.3.2-0.6.GA_CP02
- Update source tarball of 3.3.2.GA_CP02
* Thu May 19 2010 Strong Liu <stliu@redhat.com> 3.3.2-0.5.GA_CP02
- Correct component-info.xml

* Thu May 19 2010 Strong Liu <stliu@redhat.com> 3.3.2-0.4.GA_CP02
- Add hibernate-testing jar

* Thu May 19 2010 Strong Liu <stliu@redhat.com> 3.3.2-0.3.GA_CP02
- rebuild

* Thu May 19 2010 Strong Liu <stliu@redhat.com> 3.3.2-0.2.GA_CP02
- correct source file name

* Thu May 19 2010 Strong Liu <stliu@redhat.com> 3.3.2-0.1.GA_CP02
- Cleanup spec
- Remove unnecessary patches 
- Add dist package
- Upgrade hibernate to 3.3.2.GA_CP02

* Wed Apr 21 2010 Weinan Li <weli@redhat.com> 3.3.2-0.12.GA_CP01
- Rebuild

* Fri Jan 29 2010 Strong Liu <stliu@redhat.com> 3.3.2-0.11.GA_CP01
- Add poms to repolib
- Change servlet-api map to servlet_2_5_api
- Change jacc-api to jacc_1_0_api

* Thu Jan 21 2010 Strong Liu <stliu@redhat.com> 3.3.2-0.10.GA_CP01
- Add JPP-jboss-javaee-parent.pom as source6
- Add BR maven2-plugin-install
- Add BR maven-jdocbook-plugin
- Add BR maven-jdocbook-style-plugin
- Add BR jboss-servlet-2.5-api
- Map javax.security:jacc:1.0 to JPP:jboss-jacc-api:1.1.0.GA_SP1
- Map javax.transaction:jta:1.1 to JPP:jboss-transaction-1.0.1-api:1.0.1.GA
- Map javax.servlet:servlet-api:2.3 to JPP:jboss-servlet-2.5-api:2.5.0.GA
- Remove javadoc.zip

* Wed Jan 20 2010 Strong Liu <stliu@redhat.com> 3.3.2-0.9.GA_CP01
- Rebuild to use the new tarball, the old source tarball has some weird files that I do not know where them came from, now I have removed them from the source tarball.

* Sat Jan 16 2010 Strong Liu <stliu@redhat.com> 3.3.2-0.8.GA_CP01
* Update release tag to include GA_CP01

* Wed Jan 14 2010 Strong Liu <stliu@redhat.com> 3.3.2-0.7
- Update hibernate3-parent-pom.xml.patch to enable maven-sources-plugin
- Add BR maven2-plugin-source
- Use the sources jar generated by maven instead of manual create

* Wed Jan 13 2010 Strong Liu <stliu@redhat.com> 3.3.2-0.6
- Upgrade hibernate to 3.3.2.GA_CP01
- Add hibernate-3.3.2.GA_CP01.src.tar.gz into tarball
- Remove hibernate3-testsuite-pom.xml.patch, doesn't need anymore
- Cleanup this spec file, remove some out-of-date comments

* Thu Nov 26 2009 Strong Liu <stliu@redhat.com> 3.3.2-0.5
- Add hibernate3-parent-pom.xml.patch to add hrefs for JDK methods to hibernate javadoc
- Add jdk-1_5_0.zip as sources5
- Update hibernate3-core-pom.xml.patch to add hrefs for JDK methods to hibernate core javadoc

* Mon Jul 20 2009 Strong Liu <stliu@redhat.com> 3.3.2-0.4
* Seperate the hibernate-sources.jar into seperate jars

* Sat Jul 18 2009 Gail Badner <gbadner@redhat.com> 3.3.2-0.3
* Check code into proper branch

* Fri Jul 17 2009 Gail Badner <gbadner@redhat.com> 3.3.2-0.2
* Update branch to RHEL-4-EP-5

* Thu Jul 16 2009 Gail Badner <gbadner@redhat.com> 3.3.2-0.1
- First JPackage release


